package net.sf.sidaof.service.jpa;

import javax.persistence.EntityManager;
import javax.persistence.LockModeType;
import javax.persistence.Query;

import net.sf.sidaof.dao.jpa.JpaDao;
import net.sf.sidaof.service.AbstractDaoService;

/**
 * Base class for services providing complete JPA DAO functionality.
 * 
 * @author Jeff Jensen
 */
public abstract class AbstractJpaDaoService<K, E> extends
        AbstractDaoService<K, E> {
    @Override
    public abstract JpaDao<K, E> getDao();

    public E findById(K id, LockModeType lockMode, boolean exceptionIfNotFound) {
        return getDao().findById(id, lockMode, exceptionIfNotFound);
    }

    // FIXME this in AbstractDao, not in JpaDao or Dao interfaces but rest are;
    // need it?
    // public Class<E> getEntityClass() {
    // return getDao().getEntityClass();
    // }

    public EntityManager getEntityManager() {
        return getDao().getEntityManager();
    }

    public E runQueryWithSingleResult(Query q, LockModeType lockMode,
            boolean exceptionIfNotFound) {
        return getDao().runQueryWithSingleResult(q, lockMode,
                exceptionIfNotFound);
    }

    public E runQueryWithSingleResult(Query q) {
        return getDao().runQueryWithSingleResult(q);
    }

    public void setEntityManager(EntityManager entityManager) {
        getDao().setEntityManager(entityManager);
    }
}
